using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InstrumentDrivers;

namespace RSSMU_ARB_Example
{
    public partial class RSSMU_ARB_Example : Form
    {
        private rssmu m_Instrument;
        public RSSMU_ARB_Example()
        {
            InitializeComponent();
        }

        private void Apply_Click(object sender, EventArgs e)
        {
            int path = 1;
            String filename;
            StringBuilder idn = new StringBuilder(256);
            String[] split;

            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                if (m_Instrument==null)
                    m_Instrument = new rssmu(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);

                m_Instrument.IdentificationQuery(idn);
                
                split = Waveform.Text.Split('\\');
                filename = split[split.Length - 1];
                if (idn.ToString().Contains("SMBV"))
                    filename = filename.Insert(0, "/hdd/");

                m_Instrument.writeFromFile(Waveform.Text, filename);
                m_Instrument.WaittoContinue();
                m_Instrument.ARBWaveformSelect(path, filename);
                m_Instrument.SetARBState(path, ARBState.Checked);
                m_Instrument.SetRFAmplitude(path, Decimal.ToDouble(RFLevel.Value));
                m_Instrument.SetRFFrequency(path, Decimal.ToDouble(RFFreq.Value));
                m_Instrument.SetOutputState(path, RFState.Checked);

                m_Instrument.Dispose();
                m_Instrument = null;
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to exit?", "Exit?", MessageBoxButtons.YesNo) == DialogResult.Yes)
                Close();
        }

        private void BrowseButton_Click(object sender, EventArgs e)
        {
            openWaveformDialog.Filter = "Waveform files (*.wv)|*.wv|All files (*.*)|*.*";
            openWaveformDialog.FilterIndex = 1;
            openWaveformDialog.InitialDirectory = Waveform.Text;
            openWaveformDialog.RestoreDirectory = true;
            openWaveformDialog.FileName = "";
            if (openWaveformDialog.ShowDialog() == DialogResult.OK)
                Waveform.Text=openWaveformDialog.FileName;
        }
    }
}